"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cached_expression_1 = require("cached-expression");
/**
 * @private
 * This class is for `AdjadentNumberedCalculator` only
 */
class AdjadentNumberedMap extends Map {
    constructor() {
        super(...arguments);
        this.maxKey = 0;
    }
    has(key) {
        return key <= this.maxKey;
    }
    set(key, value) {
        if (this.maxKey < key) {
            this.maxKey = key;
        }
        super.set(key, value);
        return this;
    }
}
/**
 * This class is useful when `calculate(n)` requires `calculate(n - 1)` (e.g. factorial)
 */
class AdjadentNumberedCalculator extends cached_expression_1.Calculator {
    createCache() {
        return new AdjadentNumberedMap();
    }
}
exports.AdjadentNumberedCalculator = AdjadentNumberedCalculator;
//# sourceMappingURL=index.js.map